<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_nnr_rlp_get_terms', 					array('NNRobots_Related_Posts_Admin', 'get_terms'));
add_action( 'wp_ajax_nnr_rlp_get_posts', 					array('NNRobots_Related_Posts_Admin', 'get_posts'));

add_action( 'wp_ajax_nnr_rlp_get_total_posts', 				array('NNRobots_Related_Posts_Admin', 'get_total_posts'));
add_action( 'wp_ajax_nnr_rlp_get_related_posts_pool', 		array('NNRobots_Related_Posts_Admin', 'get_related_posts_pool'));

add_action( 'wp_ajax_nnr_rlp_clear_cache', 					array('NNRobots_Related_Posts_Admin', 'clear_cache'));

add_action( 'add_meta_boxes', 								array('NNRobots_Related_Posts_Admin', 'add_meta_box'), 10, 2 );
add_action( 'save_post', 									array('NNRobots_Related_Posts_Admin', 'save_meta_data'));

add_action( 'media_buttons', 								array('NNRobots_Related_Posts_Admin', 'add_shortcode_button'), 15);
add_action( 'wp_enqueue_media', 							array('NNRobots_Related_Posts_Admin', 'include_shortcode_button_scripts'));


add_action( 'wp_ajax_nnr_rlp_shortcode_increment', 			array('NNRobots_Related_Posts_Admin', 'shortcodeIncrement'));
add_action( 'wp_ajax_nopriv_nnr_rlp_shortcode_increment',	array('NNRobots_Related_Posts_Admin', 'shortcodeIncrement'));

class NNRobots_Related_Posts_Admin {

	/**
	 * Add shortcode button to WP Editor
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_shortcode_button() {

		// Get ID

		$shortcode_counter = get_option(NNRobots_Related_Posts::$prefix . 'shortcode_counter');

		if ($shortcode_counter === false) {
	   		$shortcode_counter = 1;
    	}

		 echo '<button class="button ' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-builder">Related Posts Pro</button>
		 <div class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-builder-container">
		 <div class="postbox ' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-builder-box" style="display:none;">
			<h3>
				<span>' . __('Related Posts Shortcode Builder', NNRobots_Related_Posts::$text_domain) . '</span>

				<button style="float: right;margin-right: 0px;" class="button ' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-builder-close">Close</button>
				<button style="float: right;margin-right: 12px;" class="button button-primary ' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-builder-add">Insert Shortcode</button>
			</h3>
			<div class="inside">';

				// Check if there are custom post types

				$custom_post_types = get_post_types(array('public'   => true,'_builtin' => false));

				if (count($custom_post_types) == 0) {
					$custom_post_types = false;
				} else {
					$custom_post_types = true;
				}

				$taxonomies = get_taxonomies(array('public' => true));
				unset($taxonomies['post_format']);

				echo '<p style="display:none;">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode">' . __( 'ShortCode:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<code class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode"></code>
				</p>

				<!-- ID -->

				<p style="display:none;">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'id">' . __( 'ID:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'id" data-shortcode="id" id="' . NNRobots_Related_Posts::$prefix_dash . 'id" name="' . NNRobots_Related_Posts::$prefix_dash . 'id" type="text" value="' . __( 'nnrobots_related_posts_' .$shortcode_counter , NNRobots_Related_Posts::$text_domain ) . '"><br/>
					<em>' . __('Use this ID to uniquely identify your related posts shortcode.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Title -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'title">' . __( 'Title:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'title" data-shortcode="title" id="' . NNRobots_Related_Posts::$prefix_dash . 'title" name="' . NNRobots_Related_Posts::$prefix_dash . 'title" type="text" value="' . __( 'Related Posts', NNRobots_Related_Posts::$text_domain ) . '"><br/>
					<em>' . __('This title is displayed above the related posts.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Layout -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'layout">' . __( 'Layout:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'layout" name="' . NNRobots_Related_Posts::$prefix_dash . 'layout" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'layout" data-shortcode="layout">
						<option value="inline_card" selected>' . __( 'Inline Card', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="stacked_card">' . __( 'Stacked Card', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="list">' . __( 'List', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="thumbnail">' . __( 'Thumbnail', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="image_flip">' . __( 'Image Flip', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="image_tile">' . __( 'Image Tiles', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="grid">' . __( 'Grid', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="slider">' . __( 'Slider', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="fancy_colors">' . __( 'Fancy Colors', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="colored_tabs">' . __( 'Colored Tabs', NNRobots_Related_Posts::$text_domain). '</option>
					</select><br/>
					<em>' . __('The layout in which the related posts will be displayed.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Related By -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'related_by">' . __('Related By', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'related-by" name="' . NNRobots_Related_Posts::$prefix_dash . 'related-by" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="related_by">
						<option value="contextual" selected="selected">' . __( 'Contextual' , NNRobots_Related_Posts::$text_domain) . '</option>';

						foreach ($taxonomies as $taxonomy) {
							echo '<option value="' . $taxonomy . '">' . __( ucfirst($taxonomy) , NNRobots_Related_Posts::$text_domain) . '</option>';
						}

					echo '</select><br/>
					<em>' . __('The way related posts are determined.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Number of Posts -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'num_of_posts">' . __( 'Number of Posts:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'num_of_posts" name="' . NNRobots_Related_Posts::$prefix_dash . 'num_of_posts" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'num_of_posts" data-shortcode="num_of_posts">';

						for ($i = 1; $i < 21; $i++) {
							echo '<option value="' . $i . '" ' . ($i == 6 ? 'selected="selected"' : '') . '>' . __($i, NNRobots_Related_Posts::$text_domain) . '</option>';
						}

					echo '</select><br/>
					<em>' . __('The total number of posts that are displayed.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Add Recent Posts -->

				<p>
					<strong><label>' . __('Add Recent Posts', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'add-recent" name="' . NNRobots_Related_Posts::$prefix_dash . 'add-recent" type="checkbox" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="add_recent">
					<em>' . __('If the number of related posts are less then the number of posts set to display then use recent posts for the remaining ones.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Order -->

				<p>
					<strong><label>' . __('Order', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'order" name="' . NNRobots_Related_Posts::$prefix_dash . 'order" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="order">
						<option value="ASC" selected="selected">' . __('ASC', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="DESC">' . __('DESC', NNRobots_Related_Posts::$text_domain) . '</option>
					</select><br/>
					<em>' . __('Designates the ascending or descending order of the Order By setting.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Order By -->

				<p>
					<strong><label>' . __('Order By', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'order-by" name="' . NNRobots_Related_Posts::$prefix_dash . 'order-by" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="order_by">
						<option value="none" data-description="No order.">' . __( 'None', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="ID" data-description="Order by post id.">' . __( 'ID', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="author" data-description="Order by author.">' . __( 'Author', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="title" data-description="Order by title.">' . __( 'Title', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="name" data-description="Order by post name.">' . __( 'Name', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="type" data-description="Order by post type.">' . __( 'Type', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="date" selected="selected" data-description="Order by date.">' . __( 'Date', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="modified" data-description="Order by last modified date.">' . __( 'Last Modified Date', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="parent" data-description="Order by post/page parent id.">' . __( 'Parent ID', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="rand" data-description="Random order.">' . __( 'Random', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="comment_count" data-description="Order by number of comments.">' . __( 'Comment Count', NNRobots_Related_Posts::$text_domain) . '</option>
						<option value="menu_order" data-description="Order by Page Order. Used most often for Pages (Order field in the Edit Page Attributes box) and for Attachments (the integer fields in the Insert / Upload Media Gallery dialog), but could be used for any post type with distinct \'menu_order\' values (they all default to 0).">' . __( 'Menu Order', NNRobots_Related_Posts::$text_domain) . '</option>
					</select><br/>
					<em class="' . NNRobots_Related_Posts::$prefix_dash . 'orderby-description"></em>
				</p>

				<!-- Number of Columns -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'num-of-columns">
					<strong><label>' . __('Number of Columns', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'num-of-columns" name="' . NNRobots_Related_Posts::$prefix_dash . 'num-of-columns" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'num_of_columns" data-shortcode="num_of_columns">';

						for ($i = 1; $i < 7; $i++) {

							if ($i == 2) {
								echo '<option value="' . $i . '" selected="selected">' . __( $i , NNRobots_Related_Posts::$text_domain) . '</option>';
							} else {
								echo '<option value="' . $i . '">' . __( $i , NNRobots_Related_Posts::$text_domain) . '</option>';
							}
						}
					echo '</select><br/>
					<em>' . __('The number of columns.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Show Category -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'post-meta">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'show_category">' . __( 'Show Category:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'show_category" name="' . NNRobots_Related_Posts::$prefix_dash . 'show_category" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="show_category" type="checkbox"><br/>
					<em>' . __('Show the first category for each post.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Show Author -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'post-meta">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'show_author">' . __( 'Show Author:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'show_author" name="' . NNRobots_Related_Posts::$prefix_dash . 'show_author" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="show_author" type="checkbox"><br/>
					<em>' . __('Show the author for each post.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Show Post Date -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'post-meta">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'show_post_date">' . __( 'Show Post Date:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'show_post_date" name="' . NNRobots_Related_Posts::$prefix_dash . 'show_post_date" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="show_post_date" type="checkbox"><br/>
					<em>' . __('Show the post date for each post.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Show Comments Count -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'comments">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'show_comments">' . __( 'Show Comments Count:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'show_comments" name="' . NNRobots_Related_Posts::$prefix_dash . 'show_comments" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input" data-shortcode="show_comments" type="checkbox"><br/>
					<em>' . __('Show the comments count for each post.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Display Asynchronously -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'async">' . __( 'Display Asynchronously:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'async" name="' . NNRobots_Related_Posts::$prefix_dash . 'async" type="checkbox" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'async" checked="checked" data-shortcode="async"><br/>
					<em>' . __('Whether or not to display data asynchronously using AJAX.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Show Navigation Items -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'show-nav">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'show_nav">' . __( 'Show Navigation Buttons:', NNRobots_Related_Posts::$text_domain) . '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'show_nav" name="' . NNRobots_Related_Posts::$prefix_dash . 'show_nav" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'show-nav" type="checkbox" data-shortcode="show_nav"><br/>
					<em>' . __('Show the previous and next buttons for the slider.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

				<!-- Grid Size -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'grid-size">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'grid_size">' . __( 'Grid Size:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<select id="' . NNRobots_Related_Posts::$prefix_dash . 'grid_size" name="' . NNRobots_Related_Posts::$prefix_dash . 'grid_size" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'grid_size" data-shortcode="grid_size">
						<option value="small">' . __( 'Small', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="medium" selected>' . __( 'Medium', NNRobots_Related_Posts::$text_domain). '</option>
						<option value="large">' . __( 'Large', NNRobots_Related_Posts::$text_domain). '</option>
					</select><br/>
					<em>' . __('The size of the images in the grid.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Style Override -->

				<p>
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'style_override">' . __( 'Theme Style Override:', NNRobots_Related_Posts::$text_domain). '</label></strong>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'style_override" name="' . NNRobots_Related_Posts::$prefix_dash . 'style_override" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'style-override" type="checkbox" data-shortcode="style_override"><br/>
					<em>' . __('Use your own custom styling for text and background, or your themes styling.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Color -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'color">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'color">' . __( 'Background Color:', NNRobots_Related_Posts::$text_domain). '</label></strong><br/>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'color" name="' . NNRobots_Related_Posts::$prefix_dash . 'color" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'color bg-color-picker" value="#d3d3d3" data-shortcode="color"><br/>
					<em>' . __('The background color of each item.', NNRobots_Related_Posts::$text_domain). '</em><br/>
					<em>' . __('Note: for the bar graph layout the color\'s opacity is set to half (0.5).', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Text Color -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'text-color">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'text_color">' . __( 'Text Color:', NNRobots_Related_Posts::$text_domain). '</label></strong><br/>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'text_color" name="' . NNRobots_Related_Posts::$prefix_dash . 'text_color" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'text-color color-picker" value="#000000" data-shortcode="text_color"><br/>
					<em>' . __('The text color for each item.', NNRobots_Related_Posts::$text_domain). '</em>
				</p>

				<!-- Fancy Colors -->

				<p class="' . NNRobots_Related_Posts::$prefix_dash . 'fancy-colors">
					<strong><label for="' . NNRobots_Related_Posts::$prefix_dash . 'fancy_colors">' . __( 'Fancy Colors:', NNRobots_Related_Posts::$text_domain) . '</label></strong><br/>
					<input id="' . NNRobots_Related_Posts::$prefix_dash . 'fancy_colors" name="' . NNRobots_Related_Posts::$prefix_dash . 'fancy_colors" value="#D14841,#F37934,#FAC51C,#61BD6D,#2C82C9,#553982" class="' . NNRobots_Related_Posts::$prefix_dash . 'shortcode-input ' . NNRobots_Related_Posts::$prefix_dash . 'fancy-colors-selectize" data-shortcode="fancy_colors"><br/>
					<em>' . __('The background color of each item.  Drag and drop to re-order colors.', NNRobots_Related_Posts::$text_domain) . '</em>
				</p>

			</div>
		</div>
		</div>';
	}

	/**
	 * Include all required files for making the Shortcode Builder work
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function include_shortcode_button_scripts() {

		if ( isset($_GET['post']) ) {

			// Scripts

			wp_enqueue_script(NNRobots_Related_Posts::$prefix . 'shortcode_builder_js', plugins_url('js/shortcode-builder.js', __FILE__), array('jquery', 'wp-color-picker'), false, true);
			wp_enqueue_script(NNRobots_Related_Posts::$prefix . 'selectize_js', plugins_url('js/selectize.min.js', __FILE__), array('jquery', 'jquery-ui-core', 'jquery-ui-sortable'));

			// Styles

			wp_enqueue_style('wp-color-picker');
			wp_enqueue_style(NNRobots_Related_Posts::$prefix . 'shortcode_builder_css', plugins_url('css/shortcode-builder.css', __FILE__));
			wp_enqueue_style(NNRobots_Related_Posts::$prefix . 'selectize_css', plugins_url('css/selectize.css', __FILE__));

			// Localize Scripts

			wp_localize_script(NNRobots_Related_Posts::$prefix . 'shortcode_builder_js', 'nnr_rlp_shortcode', array(
				'prefix' 	=> NNRobots_Related_Posts::$prefix_dash,
				'ajaxurl'	=> admin_url( 'admin-ajax.php' ),
			));
		}
	}

	/**
	 * Adds 1 to the shortcode counter everytime someone clicks the insert shortcode button
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function shortcodeIncrement() {

		$shortcode_counter = get_option(NNRobots_Related_Posts::$prefix . 'shortcode_counter');

		if ($shortcode_counter === false) {
	   		$shortcode_counter = 1;
    	}

    	$shortcode_counter++;

    	update_option(NNRobots_Related_Posts::$prefix . 'shortcode_counter', $shortcode_counter);

    	echo $shortcode_counter;
    	die();
	}

	/**
	 * Adds a meta box to the post edit screen for user to add cutom related posts
	 *
	 * @access public
	 * @static
	 * @param mixed $post_type
	 * @param mixed $post
	 * @return void
	 */
	static function add_meta_box($post_type, $post) {

		add_meta_box(
			NNRobots_Related_Posts::$prefix . 'meta_box',
			__('Related Posts Pro', NNRobots_Related_Posts::$text_domain),
			array('NNRobots_Related_Posts_Admin' , 'display_meta_box'),
			$post_type,
			'side',
			'default'
		);
	}

	/**
	 * Displays the post meta box.
	 *
	 * @access public
	 * @param mixed $post
	 * @return void
	 */
	static function display_meta_box( $post ) {

		// Add a nonce field so we can check for it later.

		wp_enqueue_style(NNRobots_Related_Posts::$prefix_dash . 'selectize_css',	NNROBOTS_RELATED_POSTS_PLUGIN_URL . '/admin/css/selectize.css');
		wp_enqueue_script(NNRobots_Related_Posts::$prefix_dash . 'selectize_js', 	NNROBOTS_RELATED_POSTS_PLUGIN_URL . '/admin/js/selectize.min.js', array('jquery', 'jquery-ui-core', 'jquery-ui-sortable'));

		?>
		<script type="text/javascript">
			jQuery(document).ready(function($){
				$.post('<?php echo admin_url( 'admin-ajax.php' ); ?>',{
						'action': 'nnr_rlp_get_posts',
						'post_type': '<?php echo $post->post_type; ?>'}, function(response) {

					response = $.parseJSON(response);

					// Create an easy interface for selecting tags

				  	var post_options = [];

				  	$.each(response, function( index, value ) {
					  	post_options.push({id: value.ID, name: value.post_title});
					});

				  	$('.<?php echo NNRobots_Related_Posts::$prefix_dash . 'related-posts'; ?>').selectize({
					  	plugins: ['drag_drop', 'remove_button'],
					  	valueField: 'id',
						labelField: 'name',
						searchField: 'name',
					  	options: post_options,
				  	});
				});
			});
		</script>
		<?php

		wp_nonce_field(NNRobots_Related_Posts::$prefix . 'meta_box_nonce', NNRobots_Related_Posts::$prefix . 'save_meta_box_data' );

		$related_posts = get_post_meta( $post->ID, NNRobots_Related_Posts::$prefix . 'meta_data' , true );

		if ( $related_posts === false ) {
			$related_posts = '';
		}

		$meta_box = '<input class="' . NNRobots_Related_Posts::$prefix_dash . 'related-posts" id="' . NNRobots_Related_Posts::$prefix_dash . 'related-posts" name="' . NNRobots_Related_Posts::$prefix_dash . 'related-posts" type="text" value="' . $related_posts . '"/><em>' . __('These posts will be used when displaying related posts for only this post.', NNRobots_Related_Posts::$text_domain) . '</em>';


		echo $meta_box;
	}

	/**
	 * Saves the custom related posts meta data
	 *
	 * @access public
	 * @static
	 * @param mixed $post_id
	 * @return void
	 */
	static function save_meta_data($post_id) {

		/*
		 * We need to verify this came from our screen and with proper authorization,
		 * because the save_post action can be triggered at other times.
		 */

		// Check if our nonce is set.
		if ( ! isset( $_POST[NNRobots_Related_Posts::$prefix . 'save_meta_box_data'] ) ) {
			return;
		}

		// Verify that the nonce is valid.
		if ( ! wp_verify_nonce($_POST[NNRobots_Related_Posts::$prefix . 'save_meta_box_data'], NNRobots_Related_Posts::$prefix . 'meta_box_nonce') ) {
			return;
		}

		// If this is an autosave, our form has not been submitted, so we don't want to do anything.
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
			return;
		}

		// Check the user's permissions.
		if ( isset( $_POST['post_type'] ) && 'page' == $_POST['post_type'] ) {

			if ( ! current_user_can( 'edit_page', $post_id ) ) {
				return;
			}

		} else {

			if ( ! current_user_can( 'edit_post', $post_id ) ) {
				return;
			}
		}

		// Make sure that it is set.
		if ( ! isset( $_POST[NNRobots_Related_Posts::$prefix_dash . 'related-posts'] ) ) {
			return;
		}

		// Sanitize user input.
		$related_posts = sanitize_text_field( $_POST[NNRobots_Related_Posts::$prefix_dash . 'related-posts'] );

		// Update the meta field in the database.

		if ($related_posts == '') {
			delete_post_meta($post_id, NNRobots_Related_Posts::$prefix . 'meta_data');
		} else {
			update_post_meta( $post_id, NNRobots_Related_Posts::$prefix . 'meta_data', $related_posts);
		}
	}

	/**
	 * Gets the total number of posts
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_total_posts(){

		$post_types = get_post_types(array('public' => true));
		unset($post_types['attachment']);

		echo count(get_posts(array(
			'public' 			=> true,
			'posts_per_page' 	=> 500,
			'post_status' 		=> 'publish',
			'post_type' 		=> $post_types
		)));

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Gets all the eliglble posts that are in the related posts pool
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_related_posts_pool(){

		// Get all posts to be exlcuded

		if ( !isset($_POST['exclude_posts']) ) {
			$_POST['exclude_posts'] = '';
		}

		// Get all terms to be excluded

		if ( !isset($_POST['exclude_terms']) ) {
			$_POST['exclude_terms'] = '';
		}

		// Get the time range

		if ( !isset($_POST['time_range']) ) {
			$_POST['time_range'] = 'all_time';
		}

		// Get the post types to include

		if ( !isset($_POST['post_type']) ) {
			$_POST['post_type'] = '';
		}

		$dates = self::getStartEndDates($_POST['time_range']);
		$start_date = $dates[0];
		$end_date = $dates[1];

		$args = array(
			'public' 			=> true,
			'post_status' 		=> 'publish',
			'post_type' 		=> explode(',', $_POST['post_type']),
			'posts_per_page' 	=> 500,
			'post__not_in' 		=> explode(',', $_POST['exclude_posts']),
		);

		// Date Range

		$args['date_query'] = array(
			array(
				'after'     => $start_date,
				'before'    => $end_date,
				'inclusive' => true,
			),
		);

		// Exclude Posts by Taxonomy

		foreach ($_POST['exclude_terms'] as $taxonomy => $value) {

			$args['tax_query'][] = array(
				'taxonomy'  => $taxonomy,
				'field'     => 'term_id',
				'terms'     => explode(',', $value),
				'operator'  => 'NOT IN'
			);
		}

		echo count(get_posts($args));

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Get start and end dates
	 *
	 * @access public
	 * @static
	 * @param mixed $time_range
	 * @return void
	 */
	public static function getStartEndDates($time_range) {

		// Determine Start and End Dates

		$end_date = date("Y-m-d");

		if (isset($time_range) && $time_range == '1_day') {
			$start_date = date("Y-m-d", mktime(0, 0, 0, date("n"), date("j") - 1, date("Y")));
		} else if (isset($time_range) && $time_range == '7_days') {
			$start_date = date("Y-m-d", mktime(0, 0, 0, date("n"), date("j") - 7, date("Y")));
		} else if (isset($time_range) && $time_range == '30_days') {
			$start_date = date("Y-m-d", mktime(0, 0, 0, date("n"), date("j") - 30, date("Y")));
		} else if (isset($time_range) && $time_range == '1_year') {
			$start_date = date("Y-m-d", mktime(0, 0, 0, date("n"), date("j"), date("Y") - 1));
		} else {
			$start_date = '';
		}

		return array($start_date, $end_date);
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		echo json_encode(get_posts('posts_per_page=500&post_type=' . $_POST['post_type']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_terms() {

		echo json_encode(get_terms($_POST['taxonomy']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Clear the cache for related posts
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function clear_cache() {

		// Clear all transient data when the user saves settings

		global $wpdb;

		$query = $wpdb->query($wpdb->prepare( "DELETE FROM {$wpdb->options} WHERE option_name LIKE %s", '%' . $wpdb->esc_like('nnr_rlp_cached_posts_') . '%'));
	}

}